package com.fusi24.entryPermitScanner.ui.setting;

import android.os.Bundle;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import androidx.appcompat.widget.Toolbar;

import com.fusi24.entryPermitScanner.R;
import com.fusi24.entryPermitScanner.base.BaseActivity;
import com.fusi24.entryPermitScanner.data.entity.DataSerialPort;
import com.fusi24.entryPermitScanner.databinding.ActivitySettingBinding;

import java.util.ArrayList;
import java.util.List;

public class SettingActivity extends BaseActivity {

    private DataSerialPort dataSerialPort;
    private List<DataSerialPort> serialPortList;
    private ActivitySettingBinding binding;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = ActivitySettingBinding.inflate(getLayoutInflater());
        View view = binding.getRoot();
        setContentView(view);

        Toolbar toolbar = findViewById(R.id.toolbar);
        TextView toolbarTitle = findViewById(R.id.toolbar_text);

        if (toolbarTitle != null && toolbar != null) {
            toolbarTitle.setText(getString(R.string.label_setting));
            setSupportActionBar(toolbar);
        }

        if (getSupportActionBar() != null) {
            getSupportActionBar().setDisplayShowTitleEnabled(false);
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        }

        dataSerialPort = new DataSerialPort();
        serialPortList = new ArrayList<>();

        getDataSerialPort();
        initEvent();
    }

    private void getDataSerialPort() {
        serialPortList.add(new DataSerialPort(1, "Serial Port 2"));
        serialPortList.add(new DataSerialPort(2, "Serial Port 3"));
        setDataSerialPort();
    }


    private void setDataSerialPort(){
        ArrayAdapter<DataSerialPort> adapter = new ArrayAdapter<>(this, android.R.layout.simple_spinner_dropdown_item, serialPortList);
        binding.spinnerSerialPort.setAdapter(adapter);
        if (getSessionManager().isSerialPort2()){
            binding.spinnerSerialPort.setSelection(0);
        } else {
            binding.spinnerSerialPort.setSelection(1);
        }
    }

    private void initEvent(){

        binding.spinnerSerialPort.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                dataSerialPort = (DataSerialPort) parent.getItemAtPosition(position);
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {
                dataSerialPort = (DataSerialPort) parent.getSelectedItem();
            }
        });

        binding.btnScan.setOnClickListener(v -> {
            if (dataSerialPort.getId() == 1){
                getSessionManager().setIsSerialport2(true);
            } else {
                getSessionManager().setIsSerialport2(false);
            }
            finish();
        });
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        if (item.getItemId()==android.R.id.home){
            finish();
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        binding = null;
    }
}
